import tempfile
import uuid
from pathlib import Path

from ffmpeg import FFmpeg
from telethon import events
from telethon.tl.custom import Message

from bot_s3rius.config import config
from bot_s3rius.utils.responses import mark_unread


@config.telegram_client.on(events.NewMessage(pattern=r"^\.reduce_vid_size"))
@mark_unread
async def find_py_package(event: events.NewMessage.Event):
    video_message: Message = await event.message.get_reply_message()
    video = video_message.video
    if video is None:
        await event.reply("Я не нашёл тут видео.")
        return

    await event.reply("Сща всё тут поправлю.")

    tmp_dir = Path(tempfile.gettempdir())
    converted_file = tmp_dir / f"{uuid.uuid4().hex}.mp4"
    file = await config.telegram_client.download_media(
        video_message,
    )

    video_path = Path(file)

    await FFmpeg().input(str(video_path)).output(
        str(converted_file), {"crf": 35}
    ).execute()

    reduced_size = (converted_file.stat().st_size / video_path.stat().st_size) * 100

    await event.reply(
        f"Reduced {reduced_size}%.",
        video=converted_file,
        supports_streaming=True,
    )

    video_path.unlink()
    converted_file.unlink()
